import java.applet.Applet;
import java.awt.*;

public class ChangingText extends Applet implements Runnable
{
	Font f = new Font( "sanserif" , Font.PLAIN , 38 );
	FontMetrics fm;

	private String testo;
	private int x,y;

	private int colR=0,colG=0,colB=0;

	private Thread aggiorna = null;;
	
	public void init() {
		setBackground( Color.white );

		// Raccolta parametri
		testo = getParameter( "testo" );
		if( testo == null ) testo = "Prova Applet";

		// Posizione Stringa
		fm = getFontMetrics(f);
		x = ( getSize().width - fm.stringWidth( testo ) )/2;
		y = ( getSize().height )/2;

		aggiorna = new Thread(this , "CambiaColori");
	}

	public void start() {
		aggiorna.start();
	}

	public void stop() {
		aggiorna = null;
	}

	public void destroy() {
	}

	public void update(Graphics screen) {
		screen.setFont( f );
		screen.setColor( new Color( colR , colG , colB ) );
		screen.drawString( testo , x , y );
	}
	
	public void run() {
		Thread me = Thread.currentThread();

		int passo = 2;

		while( me == aggiorna ) {
			if( ( colB == 254 && passo > 0) || ( ( (colB == 0) && (colR == 0) && (colG == 0) ) && passo<0 ) )
				passo = -passo;
			else if( (colG == 254 && passo > 0) || ( colB == 0 && passo < 0 ) )
				colG += passo;
			else if( (colR == 254 && passo > 0) || ( colR == 0 && passo < 0 ) )
				colB +=passo;
			else 
				colR += passo;
			
			try
			{
				Thread.sleep(10);	
			}
			catch ( InterruptedException e )
			{
				System.err.println( "Thread interrotto!" );
			}
			repaint();
		}
	}
		
}
